import java.util.*;

public class CardColor
{
  public static final String White = "W";
  public static final String Blue  = "U";
  public static final String Black = "B";
  public static final String Red   = "R";
  public static final String Green = "G";

  public static final String Colorless = "C";
  public static final String Multi = "M";
  public static final String Land = "L";

  //return one string from above
  //if Colorless is returned, it is an artifact and not a land
  //ArrayList listCardInfo is from IO_Read.getCardInfo()
  public static String getType(ArrayList listCardInfo)
  {
    String type = listCardInfo.get(2).toString();
    if(0 <= type.indexOf("Land"))
      return Land;

    return getColor(listCardInfo.get(1).toString());
  }//getType()


  //returns one value from the above values except for "L" for land
  public static String getColor(String manaCost)
  {
    String m = manaCost;
    Set colors = new HashSet();

    for(int i = 0; i < m.length(); i++)
    {
      switch(m.charAt(i))
      {
        case ' ': break;
        case 'W': colors.add(White); break;
        case 'U': colors.add(Blue) ; break;
        case 'B': colors.add(Black); break;
        case 'R': colors.add(Red)  ; break;
        case 'G': colors.add(Green); break;
      }
    }

    if(colors.isEmpty())
      return Colorless;

    if(colors.size() == 1)
    {
      Object c = colors.iterator().next();
      return (String) c;
    }

    return Multi;
  }//getColor()

  public static void main(String[] args)
  {
    String[] test = {"GW", "GW GW GW", "2 GW GW", "2/R"};

    for(int i = 0; i < test.length; i++)
      System.out.println(CardColor.getColor(test[i]));
  }
}