import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.*;
import javax.swing.border.*;

import java.util.*;

public class Gui extends JFrame
{
  private IO_Read ioRead;
  private boolean isWorkingOnQuest;

  private Border border1;
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JTable jTable1 = new JTable();
  private JPanel picturePanel = new JPanel();
  private JScrollPane jScrollPane2 = new JScrollPane();
  private JTextArea cardTextArea = new JTextArea();
  private BorderLayout borderLayout1 = new BorderLayout();

  public Gui()
  {
    int yesOrNo = javax.swing.JOptionPane.showConfirmDialog(null, "Do you want to edit quest booster files?", "Edit Quest", JOptionPane.YES_NO_OPTION);
    if(yesOrNo == JOptionPane.YES_OPTION)
    {
      //System.out.println("yes to edit quest files");
      Filename.editQuestBooster();
    }

    //must set this otherwise the uppper right X will
    //always close the application
    this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

    addWindowListener(new WindowAdapter()
    {
      public void windowClosing(WindowEvent we)
      {
        closeProgram();
      }
    });

    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

    //must be before setVisible(true);
    addMenu();

    ioRead = new IO_Read();

    jTable1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jTable1.setModel(new GuiTable(ioRead));

    addTableListener(jTable1);

  }//constructor()

  //I thought I might put more stuff in this method, but I didn't
  public void writeAllFiles(GuiTable_Rarity g)
  {
    IO_Write.writeAllFiles(g);
  }//writeAllFiles()


  //get card picture and card text
  //update right side of the gui
  private void updateCardDetail(int row)
  {
    String cardName = (String) jTable1.getValueAt(row, 0);

    //convert ArrayList to a String with line breaks
    String s = "";
    ArrayList list = ioRead.getCardInfo(cardName);
    for(int i = 0; i < list.size(); i++)
      s += list.get(i).toString() +"\r\n";

    //add rarity to bottom of card text
    GuiTable tableModel = (GuiTable)jTable1.getModel();
    GuiTable_Rarity tableRarity = tableModel.getRarity();
    String rarity = tableRarity.getRarity(cardName);

    if(0 < rarity.length())
      s += "\r\n" +rarity;

    cardTextArea.setText(s);

    picturePanel.removeAll();
    picturePanel.add(ioRead.getCardPicture(cardName));
    picturePanel.repaint();
    picturePanel.revalidate();
  }//updateCardDetail()

  private void addTableListener(final JTable table)
  {
    table.addKeyListener(new KeyAdapter()
    {
      GuiTable model = (GuiTable) table.getModel();
      GuiTable_Rarity rarity = model.getGuiTable_Rarity();

      public void keyReleased(KeyEvent k)
      {
        int row = table.getSelectedRow();
        if(row != -1)
          updateCardDetail(row);
      }

      public void keyPressed(KeyEvent k)
      {
        int row = table.getSelectedRow();
        if(row != -1)
        {
          String cardName = (String) jTable1.getValueAt(row, 0);

          if(k.getKeyCode() == KeyEvent.VK_Z)
            rarity.changeRarity(cardName, "C");

          if(k.getKeyCode() == KeyEvent.VK_X)
            rarity.changeRarity(cardName, "U");

          if(k.getKeyCode() == KeyEvent.VK_C)
            rarity.changeRarity(cardName, "R");

          if(k.getKeyCode() == KeyEvent.VK_V)
            rarity.changeRarity(cardName, "none");

          jTable1.repaint();

          updateCardDetail(row);

        }//if valid row

      }//keyPressed()
    });//end

    table.addMouseMotionListener(new MouseMotionAdapter()
    {
      public void mouseMoved(MouseEvent m)
      {
        //System.out.println("mouse moved");

        int row = table.rowAtPoint(m.getPoint());
        int column = table.columnAtPoint(m.getPoint());

        if(row != -1 && column != -1)
        {
          jTable1.setRowSelectionInterval(row, row);
          updateCardDetail(row);
        }//if valid row and column
      }//mouseMoved()
    });//end

    table.addMouseListener(new MouseAdapter()
    {
      public void mousePressed(MouseEvent m)
      {
        int row = table.rowAtPoint(m.getPoint());
        int column = table.columnAtPoint(m.getPoint());

        if(row != -1 && column != -1)
        {
          String cardName = (String) table.getValueAt(row, 0);
          String newRarity = "";

          //did the user click on a rarity and not just the card name?
          if(0 < column)
          {
            if(1 == column)
              newRarity = "C";
            if(2 == column)
              newRarity = "U";
            if(3 ==  column)
              newRarity = "R";

            GuiTable model = (GuiTable) table.getModel();
            GuiTable_Rarity tableRarity = model.getGuiTable_Rarity();

            //check to see if the user wants to remove the card's rarity
            //i.e. make it blank
            //this is a wierd way for checking the previous rarity of the card
            if(newRarity.equals("C") && tableRarity.isCommon(cardName))
              newRarity = "none";

            if(newRarity.equals("U") && tableRarity.isUncommon(cardName))
              newRarity = "none";

            if(newRarity.equals("R") && tableRarity.isRare(cardName))
              newRarity = "none";

            tableRarity.changeRarity(cardName, newRarity);
            model.fireTableRowsUpdated(row, row);

            //System.out.println("changed: " +cardName +" - " +newRarity);

          }//if
        }//if
        //fireTableCellupdated(row, column)
      }
    });
  }//addTableListener()

  private void addMenu()
  {
    JMenuBar menuBar = new JMenuBar();
    menuBar.add(getMenuSet());
    menuBar.add(getMenuSort());
    menuBar.add(getStatisticsMenu());

    this.setJMenuBar(menuBar);

  }//addMenu()


  private JMenu getStatisticsMenu()
  {
//    JMenuItem open = new JMenuItem("Open Set");
//    JMenuItem newSetModify = new JMenuItem("New Set - modify rarity");
//    JMenuItem newSetBlank = new JMenuItem("New Set - blank rarity");
    JMenuItem viewStats = new JMenuItem("View Statistics");
    viewStats.setAccelerator(KeyStroke.getKeyStroke('S', Event.CTRL_MASK));

    viewStats.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent a)
      {
        //must save files in order for GenerateStatistics to work
        //GenerateStatistics uses IO_Read
        GuiTable model = (GuiTable) jTable1.getModel();
        Gui.this.writeAllFiles(model.getRarity());


        GenerateStatistics stats = new GenerateStatistics(ioRead);

        JTextArea area = new JTextArea(stats.getStatistics(), 25, 40);
        area.setFont(new java.awt.Font("Dialog", 0, 16));

        JScrollPane scroll = new JScrollPane(area);
        JOptionPane.showMessageDialog(null, scroll, "Statistics", JOptionPane.INFORMATION_MESSAGE);
      }//actionPerformed()
    });

    JMenu setMenu = new JMenu("Statistics");
    setMenu.add(viewStats);

    return setMenu;
  }//getStatisticsMenu()



  private JMenu getMenuSet()
  {
//    JMenuItem open = new JMenuItem("Open Set");
//    JMenuItem newSetModify = new JMenuItem("New Set - modify rarity");
//    JMenuItem newSetBlank = new JMenuItem("New Set - blank rarity");
    JMenuItem save = new JMenuItem("Save");
    //save.setAccelerator(KeyStroke.getKeyStroke('S', Event.CTRL_MASK));

    JMenuItem exit = new JMenuItem("Exit");

    //save
    save.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent a)
      {
        try{
          GuiTable model = (GuiTable) jTable1.getModel();
          Gui.this.writeAllFiles(model.getRarity());

          JOptionPane.showMessageDialog(null, "Everything has been saved");
        }
        catch(Exception ex)
        {
          Error.report("Gui : getMenuSet() save error, your files have not been saved - " +ex);
        }
      }//actionPerformed()
    });


    //exit
    exit.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent a)
      {
         closeProgram();
      }
    });

    JMenu setMenu = new JMenu("File");
    setMenu.add(save);
    setMenu.add(exit);

    return setMenu;
  }//getSetMenu()


  private JMenu getMenuSort()
  {
    JMenuItem sortName = new JMenuItem("Card Name");
    JMenuItem sortColorType = new JMenuItem("Color and Type");
    JMenuItem sortColor = new JMenuItem("Color");
    JMenuItem sortType = new JMenuItem("Type");
    JMenuItem sortRarity = new JMenuItem("Rarity");

    //card name
    sortName.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent a)
      {
        GuiTable model = (GuiTable)  jTable1.getModel();
        model.sortBy(GuiTable_Sorter.CardName);

        jTable1.repaint();
      }
    });

    //color and type
    sortColorType.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent a)
      {
        GuiTable model = (GuiTable)  jTable1.getModel();
        model.sortBy(GuiTable_Sorter.CardName);
        model.sortBy(GuiTable_Sorter.Type);
        model.sortBy(GuiTable_Sorter.Color);

        jTable1.repaint();
      }
    });


    //type
    sortType.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent a)
      {
        GuiTable model = (GuiTable)  jTable1.getModel();
        model.sortBy(GuiTable_Sorter.Type);

        jTable1.repaint();
      }
    });


    //color
    sortColor.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent a)
      {
        GuiTable model = (GuiTable)  jTable1.getModel();
        model.sortBy(GuiTable_Sorter.Color);

        jTable1.repaint();
      }
    });


    //rarity
    sortRarity.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent a)
      {
        GuiTable model = (GuiTable)  jTable1.getModel();
        model.sortBy(GuiTable_Sorter.Rarity);

        jTable1.repaint();
      }
    });


    JMenu sortMenu = new JMenu("Sort By");
    sortMenu.add(sortName);
    sortMenu.add(sortColorType);
    sortMenu.add(sortColor);
    sortMenu.add(sortType);
    sortMenu.add(sortRarity);

    return sortMenu;
  }//getSortMenu()

  public void closeProgram()
  {
    int n = JOptionPane.showConfirmDialog(null, "Do you want to exit?", "Exit", JOptionPane.YES_NO_OPTION);

    if(n == JOptionPane.YES_OPTION)
      System.exit(0);
  }

  private void jbInit() throws Exception
  {
    this.getContentPane().setLayout(null);
    jScrollPane1.setBounds(new Rectangle(7, 8, 460, 634));
    picturePanel.setBorder(BorderFactory.createEtchedBorder());
    picturePanel.setBounds(new Rectangle(488, 9, 272, 330));
    picturePanel.setLayout(borderLayout1);
    jScrollPane2.setBounds(new Rectangle(489, 353, 401, 286));
    cardTextArea.setEnabled(false);
    cardTextArea.setFont(new java.awt.Font("Dialog", 0, 16));
    cardTextArea.setDisabledTextColor(Color.black);
    cardTextArea.setLineWrap(true);
    cardTextArea.setWrapStyleWord(true);
    jTable1.setFont(new java.awt.Font("Dialog", 0, 14));
    this.getContentPane().add(jScrollPane1, null);
    this.getContentPane().add(picturePanel, null);
    this.getContentPane().add(jScrollPane2, null);
    jScrollPane2.getViewport().add(cardTextArea, null);
    jScrollPane1.getViewport().add(jTable1, null);
  }

  public static void main(String[] args)
  {
    Gui gui = new Gui();

    GenerateStatistics stats = new GenerateStatistics(gui.ioRead);

    JTextArea area = new JTextArea(stats.getStatistics(), 25, 40);
    area.setFont(new java.awt.Font("Dialog", 0, 16));

    JScrollPane scroll = new JScrollPane(area);
    JOptionPane.showMessageDialog(null, scroll, "Statistics", JOptionPane.INFORMATION_MESSAGE);

    System.exit(0);
  }
}