import java.util.*;

import javax.swing.*;
import javax.swing.table.*;

public class GuiTable extends AbstractTableModel
{
  private GuiTable_Rarity cardRarity;
  private GuiTable_Sorter tableSorter;

  //cardNames will be used as an index
  private ArrayList nameList;

  public GuiTable(IO_Read io)
  {
    nameList = io.getAllCardNames();
    Collections.sort(nameList); //very important

    cardRarity = new GuiTable_Rarity(io);
    tableSorter = new GuiTable_Sorter(io, cardRarity);
  }

  public GuiTable_Rarity getRarity() {return cardRarity;}

  //example: sortBy can be "GuiTable_Sorter.CardName"
  public void sortBy(String sortBy)
  {
    tableSorter.sortBy(sortBy);
    Collections.sort(nameList, tableSorter);
  }

  public GuiTable_Rarity getGuiTable_Rarity() {return cardRarity;}


  public Object getValueAt(int rowIndex, int columnIndex)
  {
    String cardName = (String) nameList.get(rowIndex);

    if(0 == columnIndex)
      return cardName;

    if(1 == columnIndex)
      if(cardRarity.isCommon(cardName))
        return "  common";

    if(2 == columnIndex)
      if(cardRarity.isUncommon(cardName))
        return "  uncommon";

    if(3 == columnIndex)
      if(cardRarity.isRare(cardName))
        return "    rare";

    return "";
  }//getValueAt()

  public int getRowCount()
  {
    return nameList.size();
  }

  public boolean isCellEditable(int row, int column)
  {
    return false;
    /*
    if(column == 0)
      return false;

    return true;
    */
  }

  public int getColumnCount() {return 4;}

  public String getColumnName(int columnIndex)
  {
    if(0 == columnIndex)
      return "Card Name";

    if(1 == columnIndex)
      return "Common";

    if(2 == columnIndex)
      return "Uncommon";

    if(3 == columnIndex)
      return "Rare";

    return "Error";
  }//getColumnName
}