import java.util.*;

//GuiTable uses this class
public class GuiTable_Rarity
{
  private HashSet common;
  private HashSet uncommon;
  private HashSet rare;

  public GuiTable_Rarity(IO_Read io)
  {
    common = new HashSet(io.getCommon());
    uncommon = new HashSet(io.getUncommon());
    rare = new HashSet(io.getRare());
  }
  public String getRarity(String cardName)
  {
    if(isCommon(cardName))
      return "Common";

    if(isUncommon(cardName))
      return "Uncommon";

    if(isRare(cardName))
      return "Rare";

    return "";
  }

  public ArrayList getCommon() {return new ArrayList(common);}
  public ArrayList getUncommon() {return new ArrayList(uncommon);}
  public ArrayList getRare() {return new ArrayList(rare);}

  public boolean isCommon(String cardName) {return common.contains(cardName);}
  public boolean isUncommon(String cardName) {return uncommon.contains(cardName);}
  public boolean isRare(String cardName) {return rare.contains(cardName);}

  //rarity can be "C", "U", "R", "none"
  public void changeRarity(String cardName, String rarity)
  {
    common.remove(cardName);
    uncommon.remove(cardName);
    rare.remove(cardName);

    //the card will have no rarity
    if(rarity.equals("none"))
      return;

    Collection c = null;
    if(rarity.equals("C"))
      c = common;
    if(rarity.equals("U"))
      c = uncommon;
    if(rarity.equals("R"))
      c = rare;

    if(c == null)
      Error.report("GuiTable_Rarity : changeRarity() invalid rarity - " +rarity +" : card - " +cardName);

    c.add(cardName);
  }//changeRarity()
}